/*
* Copyright (c) 京北方信息技术股份有限公司 Corporation 2022 . All rights reserved.
*
*/
package net.northking.cctp.dw.api.service;

import net.northking.cctp.common.db.excel.ExcelService;
import net.northking.cctp.common.db.Pagination;
import net.northking.cctp.common.http.QueryByPage;
import net.northking.cctp.dw.dto.*;

import java.util.List;

/**
 * dw用例表Restful逻辑接口
 * @author maven-cctp-plugin
 * @since 1.0
 */
public interface DwCaseDesignInfoApiService extends ExcelService
{
  /**
   * 查询dw用例表列表
   *
   * @param queryByPage  查询条件
   * @return 查询结果列表
   */
  Pagination<DwCaseDesignInfoDetailDto> pagingQuery(QueryByPage<DwCaseDesignInfoQueryDto> queryByPage);

  /**
   * 新增dw用例表
   *
   * @param dto         接口数据传输对象
   * @return 主键
   */
  String add(DwCaseDesignInfoAddDto dto);

  /**
   * 更新dw用例表
   *
   * @param dto         接口数据传输对象
   * @return 修改的记录数量
   */
  Integer updateByPK(DwCaseDesignInfoUpdateDto dto) throws IllegalAccessException;

  /**
   * 获取dw用例表
   * @param uuid 主键
   * @return 接口数据传输对象
   */
  DwCaseDesignInfoDetailDto findByPK(String uuid);

  /**
   * 删除dw用例表
   * @param uuid  主键
   * @return 删除的记录数量
   */
  Integer deleteByPK(String uuid);

    /**
     * 批量新增
     *
     * @param batch 集合
     * @return 成功的数量
     */
    List<String> addBatch(List<DwCaseDesignInfoAddDto> batch);

    /**
     * 批量更新
     *
     * @param batch 集合
     * @return 成功的数量
     */
    Integer updateBatch(List<DwCaseDesignInfoUpdateDto> batch) throws IllegalAccessException;

    /**
     * 批量删除
     *
     * @param batch 集合
     * @return 成功的数量
     */
    Integer deleteBatch(List<Object> batch);

    List<MtCaseDesignChartDetailDto> listQuery(DwCaseDesignInfoQueryDto query);
}
